import React from 'react';
import { inject, observer } from 'mobx-react';

import { WeaErrorPage, WeaTools, WeaNewScroll, WeaLocaleProvider } from 'ecCom';
import { Pagination } from 'antd';
import * as mobx from 'mobx'
import { getBrowserVersion } from '../../util/common';
const getLabel = WeaLocaleProvider.getLabel;

@inject('budgetingStore')
@observer
class BudgetingCompare extends React.Component {

  constructor(props) {
    super(props);
    this.state = {
      showGroupHeight: true,
      budgetConditionHeight: 0
    };
  }

  componentDidMount() {

  }

  componentWillReceiveProps(nextProps) {

  }

  shouldComponentUpdate(nextProps, nextState) {

    return true;
  }

  componentWillUnmount() {
    //组件卸载时一般清理一些状态

  }


  render() {

    const { budgetingStore } = this.props;
    const { pageIndex, pageSize, rsAllCnt, qCount, compareData, updata } = budgetingStore;
    const { versionFirstMap, versionSecondMap, changeBudgetMap, leftTreeOnOff, leftTreeWidth, leftTreeOnOff_middle } = budgetingStore;

    let contentHeigh = jQuery(".wea-new-top-content").height();
    let budgetTabHeight = jQuery(".fna_budget_tab").height();
    let tabHeight = jQuery(".ant-row.wea-title").height();  //基本信息 搜索面板		
    let budgetPeriodHeight = jQuery(".fna_budget_period_tab").height();
    let pageHeight = jQuery(".fna_page").height();
    let budgetHeight = 0;

    if (this.state.showGroupHeight && jQuery(".fna_budget_condition").height()) {
      this.setState({
        showGroupHeight: false,
        budgetConditionHeight: jQuery(".fna_budget_condition").height()
      })
    }

    if (updata) {
      budgetHeight = contentHeigh - budgetTabHeight - this.state.budgetConditionHeight - tabHeight - budgetPeriodHeight - pageHeight - 15;
    } else {
      budgetHeight = contentHeigh - budgetTabHeight - tabHeight - budgetPeriodHeight - pageHeight - 15;
    }

    let leftData = []; //左边固定列内容
    let dateGroup = [];//日期列
    let subjectGroup = [];//科目行   List<subjectInfo>
    let dateGroup2 = []; //日期列

    let widthLength = '100%';
    if (qCount == 12) {
      widthLength = '2400px';
    }

    for (let i = 1; i <= qCount; i++) {
      dateGroup.push(<th span={12 / qCount}>{i}{getLabel(15372, '期')}</th>);
      dateGroup2.push(<th style={{ 'border-bottom': '1px solid #e2ecf2' }} span={12 / qCount} class='thead_data'>{i}{getLabel(15372, '期')}</th>);
    }

    compareData.forEach(dataObj => {
      let subjectId = dataObj.subjectId;
      //let archive = dataObj.archive;//封存
      let archiveHtml = dataObj.archiveHtml;
      let showGroupctrl = dataObj.showGroupctrl;//显示下级统一费控
      let groupctrlId = dataObj.groupctrlId;
      let showBottomLine = dataObj.showBottomLine;
      let styleStr = {};
      let styleHideBorder = {};
      if (showBottomLine) {
        styleStr = { 'border-bottom': '1px solid #A9A9A9' };
        styleHideBorder = { 'border-bottom': '1px solid transparent' };
      }

      let versionFirstGroup = [];
      let versionSecondGroup = [];
      let changeBudgetGroup = [];
      let sumGroup = [];

      for (let i = 1; i <= qCount; i++) {
        let versionFirstAmount = versionFirstMap['subject_' + subjectId + '_' + i];
        let versionSecondAmount = versionSecondMap['subject_' + subjectId + '_' + i];
        let changeBudgetAmount = changeBudgetMap['subject_' + subjectId + '_' + i];

        //<div dangerouslySetInnerHTML={{__html: record.otherIdspan}}/>
        if (showGroupctrl) {
          sumGroup.push(<td className="fna_amount fna_budget_Subject" span={12 / qCount}>&nbsp;</td>);
        }
        versionFirstGroup.push(<td className="fna_amount" span={12 / qCount}><div dangerouslySetInnerHTML={{ __html: versionFirstAmount }} /></td>);
        versionSecondGroup.push(<td className="fna_amount" span={12 / qCount}><div dangerouslySetInnerHTML={{ __html: versionSecondAmount }} /></td>);
        changeBudgetGroup.push(<td style={styleStr} className="fna_amount" span={12 / qCount}><div dangerouslySetInnerHTML={{ __html: changeBudgetAmount }} /></td>);
      }
      if (showGroupctrl) {
        sumGroup.push(<td className="fna_amount fna_budget_Subject" span={4}></td>);
      }
      let changeBudgetSum = changeBudgetMap['subject_' + subjectId + '_ALL'];

      let leftTab_width;
      let rightTab_width;
      if (leftTreeOnOff && leftTreeOnOff_middle) {
        leftTab_width = ((jQuery('body').width() - leftTreeWidth - leftTreeWidth) * 0.3 * 0.55);
        rightTab_width = ((jQuery('body').width() - leftTreeWidth - leftTreeWidth) * 0.3 * 0.40);
      } else if (leftTreeOnOff || leftTreeOnOff_middle) {
        leftTab_width = jQuery('.e9theme-bs-main') ? ((jQuery('body').width() - leftTreeWidth) * 0.3 * 0.55) : ((jQuery('body').width() - leftTreeWidth) * 0.3 * 0.55);
        rightTab_width = jQuery('.e9theme-bs-main') ? ((jQuery('body').width() - leftTreeWidth) * 0.3 * 0.40) : ((jQuery('body').width() - leftTreeWidth) * 0.3 * 0.40);
      } else {
        leftTab_width = jQuery('.e9theme-bs-main') ? ((jQuery('body').width()) * 0.3 * 0.55) : ((jQuery('body').width()) * 0.3 * 0.55);
        rightTab_width = jQuery('.e9theme-bs-main') ? ((jQuery('body').width()) * 0.3 * 0.40) : ((jQuery('body').width()) * 0.3 * 0.40);
      }

      versionFirstGroup.push(<td className="fna_amount" span={4}>{versionFirstMap['subject_' + subjectId + '_ALL']}</td>);
      versionSecondGroup.push(<td className="fna_amount" span={4}>{versionSecondMap['subject_' + subjectId + '_ALL']}</td>);
      changeBudgetGroup.push(<td style={styleStr} className="fna_amount" span={4}><div dangerouslySetInnerHTML={{ __html: changeBudgetSum }} /></td>);

      // 版本比对：项目预算value
      versionFirstGroup.push(<td className="fna_amount" span={4}>{versionFirstMap['subject_' + subjectId + '_PRO']}</td>);
      versionSecondGroup.push(<td className="fna_amount" span={4}>{versionSecondMap['subject_' + subjectId + '_PRO']}</td>);
      changeBudgetGroup.push(<td style={styleStr} className="fna_amount" span={4}><div dangerouslySetInnerHTML={{ __html: changeBudgetMap['subject_' + subjectId + '_PRO'] }} /></td>);

      if (showGroupctrl) {
        subjectGroup.push(<tr className="fna_tr">{sumGroup}</tr>);
        leftData.push(
          <tr className="fna_tr">
            <td className="fna_budget_Subject fna_budget_Subject_padding" title={dataObj.groupctrlSubjectName} >
              <div dangerouslySetInnerHTML={{ __html: dataObj.groupctrlSubjectName }} style={{ width: (leftTab_width - 50), overflow: 'hidden', 'text-overflow': 'ellipsis', 'white-space': 'nowrap' }} />
            </td>
            <td className="fna_budget_Subject" style={{ width: '40%' }}></td>
          </tr>);
      }
      subjectGroup.push(<tr className="fna_tr_info">{versionFirstGroup}</tr>);
      subjectGroup.push(<tr className="fna_tr_info">{versionSecondGroup}</tr>);
      subjectGroup.push(<tr className="fna_tr">{changeBudgetGroup}</tr>);

      let isChromeStyle = { width: (leftTab_width - 50), overflow: 'hidden', 'text-overflow': 'ellipsis', '-webkit-line-clamp': '3', 'display': '-webkit-box', '-webkit-box-orient': 'vertical' };
      let notChromeStyle = { width: (leftTab_width - 50), overflow: 'hidden', 'text-overflow': 'ellipsis', height: '90px' };
      let isChrome = getBrowserVersion() === 'Chrome' ? isChromeStyle : notChromeStyle;

      leftData.push(<tr className="fna_tr_info">
        <td className="fna_budget_Subject fna_budget_Subject_padding" span={4} title={dataObj.subjectName} style={{ 'border-bottom': '1px solid #A9A9A9' }} rowspan="3">
          <div style={isChrome}>
            {dataObj.subjectName}
          </div>
        </td>

        {/* <td span={4}>{dataObj.versionFirstName}</td> */}
        <td span={4} title={dataObj.versionFirstName}>
          <div dangerouslySetInnerHTML={{ __html: dataObj.versionFirstName }} style={{ width: (rightTab_width - 50), overflow: 'hidden', 'text-overflow': 'ellipsis', 'white-space': 'nowrap' }} />
        </td>
      </tr>);
      // leftData.push(
      // 	<tr className="fna_tr_info">
      // 		<td className="fna_budget_Subject" span={4}><div dangerouslySetInnerHTML={{__html: archiveHtml}}/></td>
      // 		<td span={4}>{dataObj.versionSecondName}</td>
      // 	</tr>);
      leftData.push(
        <tr className="fna_tr_info">
          <td span={4} title={dataObj.versionSecondName}>
            <div dangerouslySetInnerHTML={{ __html: dataObj.versionSecondName }} style={{ width: (rightTab_width - 50), overflow: 'hidden', 'text-overflow': 'ellipsis', 'white-space': 'nowrap' }} />
          </td>
        </tr>);
      // leftData.push(
      // 	<tr className="fna_tr">
      // 		<td style={styleStr} span={4}></td>
      // 		<td style={styleStr} span={4}>{dataObj.changeBudgetName}</td>
      // 	</tr>);
      leftData.push(
        <tr className="fna_tr">
          <td style={styleStr} span={4} title={dataObj.changeBudgetName}>
            <div dangerouslySetInnerHTML={{ __html: dataObj.changeBudgetName }} style={{ width: (rightTab_width - 50), overflow: 'hidden', 'text-overflow': 'ellipsis', 'white-space': 'nowrap' }} />
          </td>
        </tr>);
    });


    let dataList = [];
    let actual_width;
    let top_div_width;
    if (qCount == '12') {
      top_div_width = '135'
      actual_width = '1755px';

      top_div_width = 100 / 14;
    } else {
      let width = jQuery('.tabTopRight').width();
      //top_div_width = width/(qCount+1);
      top_div_width = 100 / (qCount + 2);

      actual_width = '100%';
    }

    jQuery('.editRight').scroll(function () {
      jQuery('.dataListMove').css('left', -jQuery('.editRight').scrollLeft());
      jQuery('.editLeftTab').css('top', -jQuery('.editRight').scrollTop());
    })

    for (let i = 1; i <= qCount; i++) {
      dataList.push(<div style={{ width: top_div_width + '%' }}>{i}{getLabel(15372, '期')}</div>);
    }

    let DivContent = [
      <div style={{ width: '100%', overflow: 'hidden' }}>
        <div class='tabTop'>
          <div class='tabTopLeft' style={{ width: '30%', position: 'relative', top: '0', left: '0', 'z-index': '999' }}>
            <div style={{ width: '100%' }} className="fna_tr_first">
              <div class='tabTop_subject' style={{ width: '55%' }}>{getLabel(15409, '科目名称')}</div>
              <div class='tabTop_statistical' style={{ width: '45%' }}>{getLabel(16893, '统计项')}</div>
            </div>
          </div>
          <div style={{ width: '70%', overflow: 'hidden', background: '#f7fbfe' }}>
            <div style={{ width: '100%', overflow: 'auto', position: 'relative', top: '0px' }} className="fna_tr_first tabTopRight">
              <div style={{ width: actual_width, position: 'relative', left: '0', top: '-8px' }} className='dataListMove'>
                {dataList}
                <div class='tabTop_all' style={{ width: (top_div_width - 1) + '%' }}>{getLabel(1013, '全年')}</div>
                <div class='tabTop_all' style={{ width: (top_div_width - 1) + '%' }}>项目总额</div>
              </div>
            </div>
          </div>
        </div>
        <div class='editLeft' style={{ width: '30%', 'max-height': (budgetHeight - 30) }}>
          <table class='editLeftTab' cellPadding='0' cellSpacing='0' style={{ width: '100%', borderRight: '1px solid #A9A9A9', position: 'relative', top: '0', left: '0', borderCollapse: 'collapse' }}>
            {leftData}
          </table>
        </div>

        <div class='editRight' style={{ 'max-height': (budgetHeight - 30), overflow: 'auto' }}>
          <table class='editRightTab' cellPadding='0' cellSpacing='0' style={{ width: actual_width, borderCollapse: 'collapse' }}>
            {subjectGroup}
          </table>
        </div>
      </div>
    ]

    let NullDivContent = [
      <div style={{ width: '100%', 'overflow-x': 'auto' }}>
        <WeaNewScroll ecId={`${this && this.props && this.props.ecId || ''}_WeaNewScroll@7oq7n9@nullDivContent`}
          height={budgetHeight}
        >
          <table style={{ width: '100%', 'border-spacing': '0px' }} >
            <tr className="fna_tr_first">
              <th span={4} style={{ 'width': '20%', 'border-bottom': '1px solid #e2ecf2' }}>{getLabel(15409, '科目名称')}</th>
              <th span={4} style={{ 'width': '13%', 'border-bottom': '1px solid #e2ecf2' }}>{getLabel(16893, '统计项')}</th>
              {dateGroup2}
              <th style={{ 'border-bottom': '1px solid #e2ecf2' }} span={4}>{getLabel(1013, '全年')}</th>
              <th style={{ 'border-bottom': '1px solid #e2ecf2' }} span={4}>项目总额</th>
            </tr>
            {subjectGroup}

          </table>

        </WeaNewScroll>
      </div>
    ]

    let content = "";
    if (rsAllCnt == '0') {
      content = NullDivContent;
    } else {
      content = DivContent;
    }

    return (
      <div>
        {content}

        <Pagination ecId={`${this && this.props && this.props.ecId || ''}_Pagination@at42zn`}
          className='fna_page'
          showSizeChanger
          showQuickJumper
          defaultCurrent={1}
          current={pageIndex}
          pageSize={pageSize}
          total={rsAllCnt}
          showTotal={total => `${getLabel(386979, '共')} ${total} ${getLabel(386978, '条')}`}
          pageSizeOptions={['10', '20', '30', '50']}
          onChange={this.pageChange}
          onShowSizeChange={this.onShowSizeChange}
        />

      </div>
    )

  }


  pageChange = (page) => {
    //console.log('page',page);
    const { budgetingStore } = this.props;
    const { compareDataList } = budgetingStore;
    const { organizationtype, organizationid, budgetperiods, tabFeeperiod } = budgetingStore;
    const { budgetinfoid_1, budgetinfoid_2 } = budgetingStore;
    const { nameQuery, clickType } = budgetingStore;
    let baseParams = { organizationtype: organizationtype, organizationid: organizationid, budgetperiods: budgetperiods, tabFeeperiod: tabFeeperiod };
    let idParams = { budgetinfoid_1: budgetinfoid_1, budgetinfoid_2: budgetinfoid_2 };
    let queryParams = { nameQuery: nameQuery };
    let params = { ...baseParams, ...queryParams, ...idParams, pageIndex: page, clickType };
    compareDataList(params);
  }

  onShowSizeChange = (current, pageSize) => {
    //console.log('current ', current);
    //console.log('pageSize ', pageSize);
    const { budgetingStore } = this.props;
    const { compareDataList } = budgetingStore;
    const { organizationtype, organizationid, budgetperiods, tabFeeperiod } = budgetingStore;
    const { budgetinfoid_1, budgetinfoid_2 } = budgetingStore;
    const { nameQuery, clickType } = budgetingStore;
    let baseParams = { organizationtype: organizationtype, organizationid: organizationid, budgetperiods: budgetperiods, tabFeeperiod: tabFeeperiod };
    let idParams = { budgetinfoid_1: budgetinfoid_1, budgetinfoid_2: budgetinfoid_2 };
    let queryParams = { nameQuery: nameQuery };
    let params = { ...baseParams, ...queryParams, ...idParams, pageSize: pageSize, pageIndex: current, clickType };
    compareDataList(params);
  }

}

export default WeaTools.tryCatch(React,
  props => <WeaErrorPage ecId={`${this && this.props && this.props.ecId || ''}_WeaErrorPage@qkf156`} msg={props.error ? props.error : getLabel(385218, '对不起,该页面异常,请联系管理员!')} />,
  { error: "" }
)(BudgetingCompare);